/*
Az ISP-probapanel nyomogomjainak es 7 szegmenses kijelzojenek egyideju kezelese.

Bal (decimalis), jobb (binaris) gomb lenyomasa-> a szamlalo tipusanak
kivalasztasi gombjai. Alapbeallitaskent egy decimalis szamlalo van kivalasztva.

Felso (eloreszamlalas), also (hatraszamlalas) gomb lenyomasa-> a szamlalasi irany
kivalasztasanak es a szamlalas elinditasanak gombjai.

Szamlalas kozben a gombok lenyomasa hatastalan, ezert szamlalasi irany, szamlalo
tipusanak kivalasztasahoz, megvaltoztatasahoz, a szamlalas ujrainditasahoz
meg kell varni  a szamlalas veget (sotet kijelzo).

A szamlalas 0,5 s-kent tortenik.
*/

#include <avr/io.h>
#include <util/delay.h>

#define DEC 10
#define BIN 16

const unsigned char szam[16] = {
                                 0x81 /*0*/, 0xD7 /*1*/, 0xA4 /*2*/, 0x94 /*3*/,
								 0xD2 /*4*/, 0x98 /*5*/, 0x88 /*6*/, 0xD5 /*7*/,
								 0x80 /*8*/, 0x90 /*9*/, 0xC0 /*A*/, 0x8A /*b*/,
								 0xA9 /*C*/, 0x86 /*d*/, 0xA8 /*E*/, 0xE8 /*F*/
								};

int main(void) {
  short i;
  unsigned char szamlalo = DEC;
  
  DDRC = 0xFF;
  PORTC = 0xFF;
  
  DDRE = 0x7F;
  PORTE = 0x80;
  
  DDRF = 0xF7;
  PORTF = 0x08;
  
  DDRG = 0x07;
  PORTG = 0x10;  

  for (;;) {

    if (bit_is_clear(PING,PING3)) szamlalo = DEC;
    
	if (bit_is_clear(PINE,PINE7)) szamlalo = BIN;
    
    if (bit_is_clear(PING,PING4)) {
	  for (i = 0; i < szamlalo; i++) {
	    PORTC = szam[i];
	    _delay_ms(500);
	  }
	  PORTC = 0xFF;
	}

    if (bit_is_clear(PINF,PINF3)) {
	  for (i = szamlalo - 1; i > -1; i--) {
	    PORTC = szam[i];
	    _delay_ms(500);
	  }
	  PORTC = 0xFF;
	}
  
  }
  
  return(0);
}
